package ch.nostromo.tiffanys.clients.desktop.gui.about;

import java.awt.BorderLayout;

import javax.swing.JScrollPane;

import ch.nostromo.lib.controller.NosResourcesException;
import ch.nostromo.lib.swing.NosPanel;
import ch.nostromo.lib.swing.NosTabbedPane;
import ch.nostromo.lib.swing.NosTextArea;
import ch.nostromo.tiffanys.clients.desktop.controller.DesktopController;

public class AboutPanel extends NosPanel {

  private static final long serialVersionUID = 1L;
  private NosTabbedPane tabbedPane;
  private NosPanel panelAbout;
  private NosPanel panelChangelog;
  private JScrollPane scrollPaneGpl;
  private NosTextArea txtChangeLog;
  private JScrollPane scrollPaneChangeLog;
  private NosTextArea txtGpl;
  private NosTextArea txtAbout;
  private JScrollPane scrollPaneAbout;
  private NosPanel panelGpl;

  public AboutPanel() throws NosResourcesException {
      initGUI();
      initNOS();
  }

  private void initGUI() throws NosResourcesException {
      {
        BorderLayout thisLayout = new BorderLayout();
        this.setLayout(thisLayout);
        this.setPreferredSize(new java.awt.Dimension(630, 403));
        {
          tabbedPane = new NosTabbedPane();
          this.add(tabbedPane, BorderLayout.CENTER);
          {
            panelAbout = new NosPanel();
            BorderLayout panelAboutLayout = new BorderLayout();
            panelAbout.setLayout(panelAboutLayout);

            tabbedPane.addTab(DesktopController.getInstance().getTranslation("About.About"), null, panelAbout, null);
            {
              scrollPaneAbout = new JScrollPane();
              panelAbout.add(scrollPaneAbout, BorderLayout.CENTER);
              {
                txtAbout = new NosTextArea();
                scrollPaneAbout.setViewportView(txtAbout);
                txtAbout.setEditable(false);
                txtAbout.setText("");
              }
            }
          }
          {
            panelChangelog = new NosPanel();
            BorderLayout panelChangelogLayout = new BorderLayout();
            tabbedPane.addTab(DesktopController.getInstance().getTranslation("About.Changelog"), null, panelChangelog, null);
            panelChangelog.setLayout(panelChangelogLayout);
            {
              scrollPaneChangeLog = new JScrollPane();
              panelChangelog.add(scrollPaneChangeLog, BorderLayout.CENTER);
              {
                txtChangeLog = new NosTextArea();
                scrollPaneChangeLog.setViewportView(txtChangeLog);
                txtChangeLog.setEditable(false);
                txtChangeLog.setText("");
              }
            }
          }
          {
            panelGpl = new NosPanel();
            BorderLayout panelGplLayout = new BorderLayout();
            panelGpl.setLayout(panelGplLayout);
            tabbedPane.addTab(DesktopController.getInstance().getTranslation("About.GPL"), null, panelGpl, null);
            {
              scrollPaneGpl = new JScrollPane();
              panelGpl.add(scrollPaneGpl, BorderLayout.CENTER);
              {
                txtGpl = new NosTextArea();
                scrollPaneGpl.setViewportView(txtGpl);
                txtGpl.setEditable(false);
                txtGpl.setText("");
              }
            }
          }
        }

      }

  }

  private void initNOS() throws NosResourcesException {
    String about = DesktopController.getInstance().loadGuiResource("credits.txt");
    String gpl = DesktopController.getInstance().loadGuiResource("gpl.txt");
    String changeLog = DesktopController.getInstance().loadGuiResource("changelog.txt");

    this.txtAbout.setText(about);
    this.txtGpl.setText(gpl);
    this.txtChangeLog.setText(changeLog);
  }

}
