package ch.nostromo.tiffanys.clients.xboard.controller;

import java.io.File;

import ch.nostromo.lib.controller.NosControllerSettings;
import ch.nostromo.lib.controller.NosSettingsException;

public class XBoardSettings extends NosControllerSettings {
  
  private static final long serialVersionUID = 1L;
  
  @SuppressWarnings("hiding")
  public boolean LOG_TO_CONSOLE = false;
  
  @SuppressWarnings("hiding")
  public String  LOG_TO_CONSOLE_DOC = "Do log to console.";
  

  public String XBOARD_FEATURES = "feature myname=\"Tiffanys\" sigint=0 sigterm=0 done=1";

  public String XBOARD_FEATURES_DOC = "XBoard Features";

  public String ENGINE = "ch.nostromo.tiffanys.engines.tiffanys.TiffanysEngine";

  public String ENGINE_DOC = "Engine";
  
  public String ENGINE_SETTINGS = "xboard-engine-settings.xml";
  
  public String ENGINE_SETTINGS_DOC  = "Engine settings";
  
  
  public XBoardSettings()  {
    super("tiffanys", "xboard.log");
  }

  public XBoardSettings(File fileToRead) throws NosSettingsException  {
    super("tiffanys", "xboard.log");
    this.readSettingsFromXml(fileToRead);
  }
  
  
}
