package ch.nostromo.tiffanys.engines.tiffanys.ai;

public class TiffanysAiTools {
  public static int[] COMMON_BOARD_VALUES = null;

  public static int[] PAWN_WHITE_VALUES = null;

  public static int[] PAWN_BLACK_VALUES = null;

  private static boolean initialized;

  public static void initialize() {
    if (initialized) {
      return;
    }

    initCommonBoardFine();
    initWhitePawnBoardsFine();
    initBlackPawnBoardsFine();
  }

  public static void initCommonBoard() {
    COMMON_BOARD_VALUES = new int[120];

    // apply values line 1
    COMMON_BOARD_VALUES[21] = 5;
    COMMON_BOARD_VALUES[22] = 0;
    COMMON_BOARD_VALUES[23] = 10;
    COMMON_BOARD_VALUES[24] = 15;
    COMMON_BOARD_VALUES[25] = 15;
    COMMON_BOARD_VALUES[26] = 10;
    COMMON_BOARD_VALUES[27] = 0;
    COMMON_BOARD_VALUES[28] = 5;

    // apply to line 8
    for (int i = 0; i < 8; i++) {
      int source = 21;
      int dest = 91;
      COMMON_BOARD_VALUES[dest + i] = COMMON_BOARD_VALUES[source + i];
    }

    // apply values line 2
    COMMON_BOARD_VALUES[31] = 5;
    COMMON_BOARD_VALUES[32] = 10;
    COMMON_BOARD_VALUES[33] = 15;
    COMMON_BOARD_VALUES[34] = 20;
    COMMON_BOARD_VALUES[35] = 20;
    COMMON_BOARD_VALUES[36] = 15;
    COMMON_BOARD_VALUES[37] = 10;
    COMMON_BOARD_VALUES[38] = 5;

    // apply to line 7
    for (int i = 0; i < 8; i++) {
      int source = 31;
      int dest = 81;
      COMMON_BOARD_VALUES[dest + i] = COMMON_BOARD_VALUES[source + i];
    }

    // apply values line 3
    COMMON_BOARD_VALUES[41] = 10;
    COMMON_BOARD_VALUES[42] = 15;
    COMMON_BOARD_VALUES[43] = 20;
    COMMON_BOARD_VALUES[44] = 25;
    COMMON_BOARD_VALUES[45] = 25;
    COMMON_BOARD_VALUES[46] = 20;
    COMMON_BOARD_VALUES[47] = 15;
    COMMON_BOARD_VALUES[48] = 10;

    // apply to line 6
    for (int i = 0; i < 8; i++) {
      int source = 41;
      int dest = 71;
      COMMON_BOARD_VALUES[dest + i] = COMMON_BOARD_VALUES[source + i];
    }

    // apply values line 4
    COMMON_BOARD_VALUES[51] = 15;
    COMMON_BOARD_VALUES[52] = 20;
    COMMON_BOARD_VALUES[53] = 25;
    COMMON_BOARD_VALUES[54] = 30;
    COMMON_BOARD_VALUES[55] = 25;
    COMMON_BOARD_VALUES[56] = 25;
    COMMON_BOARD_VALUES[57] = 20;
    COMMON_BOARD_VALUES[58] = 15;

    // apply to line 4
    for (int i = 0; i < 8; i++) {
      int source = 51;
      int dest = 61;
      COMMON_BOARD_VALUES[dest + i] = COMMON_BOARD_VALUES[source + i];
    }

  }

  public static void initCommonBoardFine() {
    COMMON_BOARD_VALUES = new int[120];

    // apply values line 1
    COMMON_BOARD_VALUES[21] = 4;
    COMMON_BOARD_VALUES[22] = 0;
    COMMON_BOARD_VALUES[23] = 8;
    COMMON_BOARD_VALUES[24] = 12;
    COMMON_BOARD_VALUES[25] = 12;
    COMMON_BOARD_VALUES[26] = 8;
    COMMON_BOARD_VALUES[27] = 0;
    COMMON_BOARD_VALUES[28] = 4;

    // apply to line 8
    for (int i = 0; i < 8; i++) {
      int source = 21;
      int dest = 91;
      COMMON_BOARD_VALUES[dest + i] = COMMON_BOARD_VALUES[source + i];
    }

    // apply values line 2
    COMMON_BOARD_VALUES[31] = 4;
    COMMON_BOARD_VALUES[32] = 8;
    COMMON_BOARD_VALUES[33] = 12;
    COMMON_BOARD_VALUES[34] = 16;
    COMMON_BOARD_VALUES[35] = 16;
    COMMON_BOARD_VALUES[36] = 12;
    COMMON_BOARD_VALUES[37] = 8;
    COMMON_BOARD_VALUES[38] = 4;

    // apply to line 7
    for (int i = 0; i < 8; i++) {
      int source = 31;
      int dest = 81;
      COMMON_BOARD_VALUES[dest + i] = COMMON_BOARD_VALUES[source + i];
    }

    // apply values line 3
    COMMON_BOARD_VALUES[41] = 8;
    COMMON_BOARD_VALUES[42] = 12;
    COMMON_BOARD_VALUES[43] = 16;
    COMMON_BOARD_VALUES[44] = 20;
    COMMON_BOARD_VALUES[45] = 20;
    COMMON_BOARD_VALUES[46] = 16;
    COMMON_BOARD_VALUES[47] = 12;
    COMMON_BOARD_VALUES[48] = 8;

    // apply to line 6
    for (int i = 0; i < 8; i++) {
      int source = 41;
      int dest = 71;
      COMMON_BOARD_VALUES[dest + i] = COMMON_BOARD_VALUES[source + i];
    }

    // apply values line 4
    COMMON_BOARD_VALUES[51] = 12;
    COMMON_BOARD_VALUES[52] = 16;
    COMMON_BOARD_VALUES[53] = 20;
    COMMON_BOARD_VALUES[54] = 24;
    COMMON_BOARD_VALUES[55] = 24;
    COMMON_BOARD_VALUES[56] = 20;
    COMMON_BOARD_VALUES[57] = 16;
    COMMON_BOARD_VALUES[58] = 12;

    // apply to line 4
    for (int i = 0; i < 8; i++) {
      int source = 51;
      int dest = 61;
      COMMON_BOARD_VALUES[dest + i] = COMMON_BOARD_VALUES[source + i];
    }

  }

  public static void initWhitePawnBoards() {

    PAWN_WHITE_VALUES = new int[120];

    PAWN_WHITE_VALUES[31] = 5;
    PAWN_WHITE_VALUES[32] = 5;
    PAWN_WHITE_VALUES[33] = 0;
    PAWN_WHITE_VALUES[34] = 0;
    PAWN_WHITE_VALUES[35] = 0;
    PAWN_WHITE_VALUES[36] = 10;
    PAWN_WHITE_VALUES[37] = 10;
    PAWN_WHITE_VALUES[38] = 10;

    PAWN_WHITE_VALUES[41] = 10;
    PAWN_WHITE_VALUES[42] = 10;
    PAWN_WHITE_VALUES[43] = 10;
    PAWN_WHITE_VALUES[44] = 10;
    PAWN_WHITE_VALUES[45] = 10;
    PAWN_WHITE_VALUES[46] = 5;
    PAWN_WHITE_VALUES[47] = 10;
    PAWN_WHITE_VALUES[48] = 10;

    PAWN_WHITE_VALUES[51] = 10;
    PAWN_WHITE_VALUES[52] = 10;
    PAWN_WHITE_VALUES[53] = 20;
    PAWN_WHITE_VALUES[54] = 25;
    PAWN_WHITE_VALUES[55] = 25;
    PAWN_WHITE_VALUES[56] = 5;
    PAWN_WHITE_VALUES[57] = 5;
    PAWN_WHITE_VALUES[58] = 5;

    PAWN_WHITE_VALUES[61] = 10;
    PAWN_WHITE_VALUES[62] = 10;
    PAWN_WHITE_VALUES[63] = 20;
    PAWN_WHITE_VALUES[64] = 30;
    PAWN_WHITE_VALUES[65] = 30;
    PAWN_WHITE_VALUES[66] = 10;
    PAWN_WHITE_VALUES[67] = 10;
    PAWN_WHITE_VALUES[68] = 10;

    PAWN_WHITE_VALUES[71] = 15;
    PAWN_WHITE_VALUES[72] = 15;
    PAWN_WHITE_VALUES[73] = 25;
    PAWN_WHITE_VALUES[74] = 30;
    PAWN_WHITE_VALUES[75] = 30;
    PAWN_WHITE_VALUES[76] = 15;
    PAWN_WHITE_VALUES[77] = 15;
    PAWN_WHITE_VALUES[78] = 15;

    PAWN_WHITE_VALUES[81] = 20;
    PAWN_WHITE_VALUES[82] = 20;
    PAWN_WHITE_VALUES[83] = 30;
    PAWN_WHITE_VALUES[84] = 35;
    PAWN_WHITE_VALUES[85] = 35;
    PAWN_WHITE_VALUES[86] = 20;
    PAWN_WHITE_VALUES[87] = 20;
    PAWN_WHITE_VALUES[88] = 20;
  }

  public static void initBlackPawnBoards() {

    PAWN_BLACK_VALUES = new int[120];

    PAWN_BLACK_VALUES[81] = 5;
    PAWN_BLACK_VALUES[82] = 5;
    PAWN_BLACK_VALUES[83] = 0;
    PAWN_BLACK_VALUES[84] = 0;
    PAWN_BLACK_VALUES[85] = 0;
    PAWN_BLACK_VALUES[86] = 10;
    PAWN_BLACK_VALUES[87] = 10;
    PAWN_BLACK_VALUES[88] = 10;

    PAWN_BLACK_VALUES[71] = 10;
    PAWN_BLACK_VALUES[72] = 10;
    PAWN_BLACK_VALUES[73] = 10;
    PAWN_BLACK_VALUES[74] = 10;
    PAWN_BLACK_VALUES[75] = 10;
    PAWN_BLACK_VALUES[76] = 5;
    PAWN_BLACK_VALUES[77] = 10;
    PAWN_BLACK_VALUES[78] = 10;

    PAWN_BLACK_VALUES[61] = 10;
    PAWN_BLACK_VALUES[62] = 10;
    PAWN_BLACK_VALUES[63] = 20;
    PAWN_BLACK_VALUES[64] = 25;
    PAWN_BLACK_VALUES[65] = 25;
    PAWN_BLACK_VALUES[66] = 5;
    PAWN_BLACK_VALUES[67] = 5;
    PAWN_BLACK_VALUES[68] = 5;

    PAWN_BLACK_VALUES[51] = 10;
    PAWN_BLACK_VALUES[52] = 10;
    PAWN_BLACK_VALUES[53] = 20;
    PAWN_BLACK_VALUES[54] = 30;
    PAWN_BLACK_VALUES[55] = 30;
    PAWN_BLACK_VALUES[56] = 10;
    PAWN_BLACK_VALUES[57] = 10;
    PAWN_BLACK_VALUES[58] = 10;

    PAWN_BLACK_VALUES[41] = 15;
    PAWN_BLACK_VALUES[42] = 15;
    PAWN_BLACK_VALUES[43] = 25;
    PAWN_BLACK_VALUES[44] = 30;
    PAWN_BLACK_VALUES[45] = 30;
    PAWN_BLACK_VALUES[46] = 15;
    PAWN_BLACK_VALUES[47] = 15;
    PAWN_BLACK_VALUES[48] = 15;

    PAWN_BLACK_VALUES[31] = 20;
    PAWN_BLACK_VALUES[32] = 20;
    PAWN_BLACK_VALUES[33] = 30;
    PAWN_BLACK_VALUES[34] = 35;
    PAWN_BLACK_VALUES[35] = 35;
    PAWN_BLACK_VALUES[36] = 20;
    PAWN_BLACK_VALUES[37] = 20;
    PAWN_BLACK_VALUES[38] = 20;

  }

  public static void initWhitePawnBoardsFine() {

    PAWN_WHITE_VALUES = new int[120];

    PAWN_WHITE_VALUES[31] = 4;
    PAWN_WHITE_VALUES[32] = 4;
    PAWN_WHITE_VALUES[33] = 0;
    PAWN_WHITE_VALUES[34] = 0;
    PAWN_WHITE_VALUES[35] = 0;
    PAWN_WHITE_VALUES[36] = 6;
    PAWN_WHITE_VALUES[37] = 6;
    PAWN_WHITE_VALUES[38] = 6;

    PAWN_WHITE_VALUES[41] = 6;
    PAWN_WHITE_VALUES[42] = 6;
    PAWN_WHITE_VALUES[43] = 8;
    PAWN_WHITE_VALUES[44] = 8;
    PAWN_WHITE_VALUES[45] = 8;
    PAWN_WHITE_VALUES[46] = 4;
    PAWN_WHITE_VALUES[47] = 6;
    PAWN_WHITE_VALUES[48] = 6;

    PAWN_WHITE_VALUES[51] = 8;
    PAWN_WHITE_VALUES[52] = 8;
    PAWN_WHITE_VALUES[53] = 16;
    PAWN_WHITE_VALUES[54] = 22;
    PAWN_WHITE_VALUES[55] = 22;
    PAWN_WHITE_VALUES[56] = 4;
    PAWN_WHITE_VALUES[57] = 4;
    PAWN_WHITE_VALUES[58] = 4;

    PAWN_WHITE_VALUES[61] = 10;
    PAWN_WHITE_VALUES[62] = 10;
    PAWN_WHITE_VALUES[63] = 20;
    PAWN_WHITE_VALUES[64] = 26;
    PAWN_WHITE_VALUES[65] = 26;
    PAWN_WHITE_VALUES[66] = 10;
    PAWN_WHITE_VALUES[67] = 10;
    PAWN_WHITE_VALUES[68] = 10;

    PAWN_WHITE_VALUES[71] = 12;
    PAWN_WHITE_VALUES[72] = 12;
    PAWN_WHITE_VALUES[73] = 22;
    PAWN_WHITE_VALUES[74] = 28;
    PAWN_WHITE_VALUES[75] = 28;
    PAWN_WHITE_VALUES[76] = 14;
    PAWN_WHITE_VALUES[77] = 14;
    PAWN_WHITE_VALUES[78] = 14;

    PAWN_WHITE_VALUES[81] = 18;
    PAWN_WHITE_VALUES[82] = 18;
    PAWN_WHITE_VALUES[83] = 28;
    PAWN_WHITE_VALUES[84] = 32;
    PAWN_WHITE_VALUES[85] = 32;
    PAWN_WHITE_VALUES[86] = 20;
    PAWN_WHITE_VALUES[87] = 20;
    PAWN_WHITE_VALUES[88] = 20;
  }

  public static void initBlackPawnBoardsFine() {

    PAWN_BLACK_VALUES = new int[120];

    PAWN_BLACK_VALUES[81] = 4;
    PAWN_BLACK_VALUES[82] = 4;
    PAWN_BLACK_VALUES[83] = 0;
    PAWN_BLACK_VALUES[84] = 0;
    PAWN_BLACK_VALUES[85] = 0;
    PAWN_BLACK_VALUES[86] = 6;
    PAWN_BLACK_VALUES[87] = 6;
    PAWN_BLACK_VALUES[88] = 6;

    PAWN_BLACK_VALUES[71] = 6;
    PAWN_BLACK_VALUES[72] = 6;
    PAWN_BLACK_VALUES[73] = 8;
    PAWN_BLACK_VALUES[74] = 8;
    PAWN_BLACK_VALUES[75] = 8;
    PAWN_BLACK_VALUES[76] = 4;
    PAWN_BLACK_VALUES[77] = 6;
    PAWN_BLACK_VALUES[78] = 6;

    PAWN_BLACK_VALUES[61] = 8;
    PAWN_BLACK_VALUES[62] = 8;
    PAWN_BLACK_VALUES[63] = 16;
    PAWN_BLACK_VALUES[64] = 22;
    PAWN_BLACK_VALUES[65] = 22;
    PAWN_BLACK_VALUES[66] = 4;
    PAWN_BLACK_VALUES[67] = 4;
    PAWN_BLACK_VALUES[68] = 4;

    PAWN_BLACK_VALUES[51] = 10;
    PAWN_BLACK_VALUES[52] = 10;
    PAWN_BLACK_VALUES[53] = 20;
    PAWN_BLACK_VALUES[54] = 26;
    PAWN_BLACK_VALUES[55] = 26;
    PAWN_BLACK_VALUES[56] = 10;
    PAWN_BLACK_VALUES[57] = 10;
    PAWN_BLACK_VALUES[58] = 10;

    PAWN_BLACK_VALUES[41] = 12;
    PAWN_BLACK_VALUES[42] = 12;
    PAWN_BLACK_VALUES[43] = 22;
    PAWN_BLACK_VALUES[44] = 28;
    PAWN_BLACK_VALUES[45] = 28;
    PAWN_BLACK_VALUES[46] = 14;
    PAWN_BLACK_VALUES[47] = 14;
    PAWN_BLACK_VALUES[48] = 14;

    PAWN_BLACK_VALUES[31] = 18;
    PAWN_BLACK_VALUES[32] = 18;
    PAWN_BLACK_VALUES[33] = 28;
    PAWN_BLACK_VALUES[34] = 32;
    PAWN_BLACK_VALUES[35] = 32;
    PAWN_BLACK_VALUES[36] = 20;
    PAWN_BLACK_VALUES[37] = 20;
    PAWN_BLACK_VALUES[38] = 20;

  }

}
