package ch.nostromo.tiffanys.engines.tiffanys.board.pieces;

import ch.nostromo.tiffanys.engines.tiffanys.board.TiffanysMove;
import ch.nostromo.tiffanys.engines.tiffanys.board.pieces.TiffanysPiece;
import ch.nostromo.tiffanys.game.board.Board;

public class TiffanysBishop extends TiffanysPiece {

  private static final int MY_PIECE_CODE = Board.PIECE_BISHOP;

  public static final int MATERIAL_VALUE = 300;

  public static int getMoveList(int[] board, int currentPosition, int myColor, int oldArrayLength, TiffanysMove[] moves) {
    int arrayLength = oldArrayLength;
    int direction = +9;
    int counter = checkDirection(board, currentPosition, myColor, direction);
    for (int i = 0; i < counter; i++) {
      moves[arrayLength] = new TiffanysMove(currentPosition, currentPosition + ((i + 1) * direction), MY_PIECE_CODE);
      arrayLength++;
    }

    direction = -9;
    counter = checkDirection(board, currentPosition, myColor, direction);
    for (int i = 0; i < counter; i++) {
      moves[arrayLength] = new TiffanysMove(currentPosition, currentPosition + ((i + 1) * direction), MY_PIECE_CODE);
      arrayLength++;
    }

    direction = +11;
    counter = checkDirection(board, currentPosition, myColor, direction);
    for (int i = 0; i < counter; i++) {
      moves[arrayLength] = new TiffanysMove(currentPosition, currentPosition + ((i + 1) * direction), MY_PIECE_CODE);
      arrayLength++;
    }

    direction = -11;
    counter = checkDirection(board, currentPosition, myColor, direction);
    for (int i = 0; i < counter; i++) {
      moves[arrayLength] = new TiffanysMove(currentPosition, currentPosition + ((i + 1) * direction), MY_PIECE_CODE);
      arrayLength++;
    }

    return arrayLength;

  }

}