package ch.nostromo.tiffanys.game.player;

import ch.nostromo.tiffanys.engines.Engine;
import ch.nostromo.tiffanys.engines.EngineSettings;

public class PlayerEngine extends Player implements Cloneable {

  private Class<Engine> engineClass = null;

  private EngineSettings engineSettings = null;

  @Override
  public PlayerEngine clone() throws CloneNotSupportedException {
    PlayerEngine result = (PlayerEngine) super.clone();

    result.engineClass = engineClass;

    result.engineSettings = engineSettings.clone();

    return result;
  }

  public PlayerEngine(Class<Engine> Class, EngineSettings engineSettings) {
    this.engineClass = Class;
    this.engineSettings = engineSettings;
  }

  public Class<Engine> getEngineClass() {
    return engineClass;
  }

  public EngineSettings getEngineSettings() {
    return engineSettings;
  }

  public Engine getEngineInstance() throws PlayerException {
    try {
      Engine engine = engineClass.newInstance();
      engine.setEngineSettings(engineSettings);
      return engine;
    } catch (InstantiationException e) {
      throw new PlayerException("InstantiationException", e);
    } catch (IllegalAccessException e) {
      throw new PlayerException("IllegalAccessException", e);
    }
  }

  @Override
  public String getPlayerName() throws PlayerException {

    return getEngineInstance().getEngineName();

  }

  public void setEngineSettings(EngineSettings engineSettings) {
    this.engineSettings = engineSettings;
  }

}
